#include <iostream>

using namespace std;

template<class T>
class Tomb{
               T* adat;
               size_t kapacitas;
               size_t elemszam;
              
               public:
                      Tomb(){
                             kapacitas=2;
                             elemszam=0;
                             adat=new T[kapacitas];
                      }
                     
                      void push_back(const T& t){
                           if(kapacitas==elemszam)  {
                                   size_t ujkap = 2*kapacitas;
                                   T* ujadat = new T[ujkap];
                                   for(int i=0; i<elemszam; ++i)
                                           ujadat[i]=adat[i];
                                   delete [] adat;
                                   kapacitas = ujkap;
                                   adat = ujadat;
                           }
                           adat[elemszam++] = t;
                      }
                     
                      T* begin(){
                         return adat;
                      }
                     
                      T* end(){
                         return adat+elemszam;
                      }
                     
                      size_t get_kap(){
                             return kapacitas;
                      }
}; // a Tomb osztlysablon vge


template<class T, template<class>class Sorozat>
class Container{
     
      Sorozat<T> sorozat;
     
      public:
             void append(const T& t){
               sorozat.push_back(t);   
             }
             size_t cap(){        // hny elem trolsra alkalmas anlkl, hogy nvelni kne a mgtte lv tmbt // size_t kb.olyan mint az unsigned int
               return sorozat.get_kap();
             }
             T* begin(){
                return sorozat.begin();
             }
             T* end(){
                return sorozat.end();
             }
};

int main() {
    Container<int, Tomb> tarolo;    // egszeket tartalmaz tmbket fog trolni
    for(int i=0; i<15; i++)
            tarolo.append(i);
    cout<<tarolo.cap()<<endl;
    int *p = tarolo.begin();
    while(p != tarolo.end())
            cout<<*p++<<endl;
    cout<<endl<<endl;
    
    Container<double, Tomb> tarolo2;    // lebegpontosakat tartalmaz tmbket fog trolni
    for(int i=1; i<15; i++)
            tarolo2.append(1.+1./i);
    cout<<tarolo2.cap()<<endl;
    double *p2 = tarolo2.begin();
    while(p2 != tarolo2.end())
            cout<<*p2++<<endl;        
            
            
  system("pause");
  return 0;           
}


