#include <iostream>

using namespace std;

template<class T, size_t N>
class Fibonacci{
               T* adat;
               size_t kapacitas;
               size_t elemszam;
              
               public:
                      Fibonacci(){
                             kapacitas=N;
                             elemszam=0;
                             adat=new T[kapacitas];
                      }
                      
                      void check() {
                           if(kapacitas==elemszam)  {
                                   size_t ujkap = 2*kapacitas;
                                   T* ujadat = new T[ujkap];
                                   for(int i=0; i<elemszam; ++i)
                                           ujadat[i]=adat[i];
                                   delete [] adat;
                                   kapacitas = ujkap;
                                   adat = ujadat;
                                  }
                           }
                     
                      void push_back(){
                           check();
                           if (elemszam==0) adat[elemszam++]=0;
                           else if (elemszam==1) adat[elemszam++]=1;
                           else adat[elemszam++]=adat[elemszam-1]+adat[elemszam-2];
                      }
                      
                      void push_back(const T& t){
                           check();
                           adat[elemszam++] = t;
                      }
                     
                      T* begin(){
                         return adat;
                      }
                     
                      T* end(){
                         return adat+elemszam;
                      }
                     
                      size_t get_kap(){
                             return kapacitas;
                      }
}; // a Tomb osztlysablon vge


template<class T, size_t N, template<class,size_t>class Sorozat>
class Container{
     
      Sorozat<T,N> sorozat;
     
      public:
             void append(){
               sorozat.push_back();   
             }
             
             void append(const T& t){
               sorozat.push_back(t);   
             }
             
             size_t cap(){        // hny elem trolsra alkalmas anlkl, hogy nvelni kne a mgtte lv tmbt // size_t kb.olyan mint az unsigned int
               return sorozat.get_kap();
             }
             T* begin(){
                return sorozat.begin();
             }
             T* end(){
                return sorozat.end();
             }
};

int main() {
  const int N=10;
  Container<int, N , Fibonacci> tarolo;
  for(int i=0;i<100;++i) if(i&1) tarolo.append(i); else tarolo.append();  
  cout<<tarolo.cap()<<endl;
  int *p = tarolo.begin();
  int i=0;
  while(p != tarolo.end())
            cout<<"A(z)" <<i++<<". elem:"<<*p++<<endl;
  cout<<endl<<endl;         
  system("pause");
  return 0;           
}


