#include <iostream>
#include <vector>
#include <list>
#include <deque>

using namespace std;

template<class T, template<class T>class Seq>
void print(const Seq<T>&);
     
int main() {
    
    vector<int> v;
    for(int i=0; i<10; ++i) v.push_back(i);
    print(v);
    
    vector<double> w;
    for(int i=0; i<10; ++i) w.push_back(1.+1./i);
    print(w);
    
    
    list<double> l;
    for(int i=0; i<10; ++i) l.push_back(1.+1./i);
    print(l);
    
    deque<double> d;
    for(int i=0; i<10; ++i) d.push_back(1.+1./i);
    print(d);
    
    
    cin.get();
    
    return 0;
}

template<class T, template<class T>class Seq>
void print(const Seq<T>& seq){
     for(typename Seq<T>::const_iterator iter=seq.begin(); iter!=seq.end(); ++iter)
        cout<<*iter<<'\t';
     cout<<endl;
}
