#include <iostream>
#include <vector>
#include <list>
#include <deque>

using namespace std;

template<class T, template<class T>class Seq>
class Tarolo{
      private:
              Seq<T> seq;
      public:
             typedef T* iterator;
             void push_back(const T& item){
                  seq.push_back(item);
             }
             iterator begin() {            // vagy: "typename Seq<T>::iterator" a visszatrsi tpusnak, akkor nem kell fent typedef
                return seq.begin();
             }
             iterator end() {
                return seq.end();
             }
             void print() {
                  for(typename Seq<T>::const_iterator iter=seq.begin(); iter!=seq.end(); ++iter)
                               cout<<*iter<<'\t';
                  cout<<endl;
             }             
};


int main() {
    
    Tarolo<int, vector>v;
    for(int i=1; i<10; ++i) v.push_back(i);
    v.print();
    
    Tarolo<double, list>l;
    for(int i=1; i<10; ++i) l.push_back(i);
    l.print();
    
    cin.get();
    return 0;
}
